<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\NewCode;
use FM\Service\FindService;
use FM\Traits\TResponse;

class FindController
{
    use TResponse;
    protected $FindService;

    public function __construct(FindService $FindService)
    {
        $this->FindService = $FindService;
    }

    public function findOperadorHierarq(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperadorHierarq($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findOperador(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperador($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findLocal(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findLocal($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findTipoLocal(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findTipoLocal($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findContratosTarefas(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findContratosTarefas($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findClientesTarefas(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findClientesTarefas($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findSolicitacoes(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findSolicitacoes($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findAtividades(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findAtividades($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    private function getFiltro($request)
    {
        if (isset($request->getParameters()["find"])) {
            $filtro = $request->getParameters()["find"];
        } else {
            $filtro = '';
        }
        return $filtro;
    }

    public function findModeloAuditoria(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findModeloAuditoria($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
