<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class FindFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function findOperador($filtro)
    {

        $sql = "SELECT CDOPERADOR, NMOPERADOR
                FROM OPERADOR
                WHERE" . $filtro . "
                ORDER BY NMOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findOperadorHierarq($filtro, $locais)
    {
        $sql = "SELECT DISTINCT OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR
                    FROM OPERADOR
                    JOIN FCM_FUNCIONARIOSHIERARQ
                    ON FCM_FUNCIONARIOSHIERARQ.CDOPERADOR = OPERADOR.CDOPERADOR
                    JOIN FCM_HIERARQUIAFUNC
                    ON FCM_HIERARQUIAFUNC.NRHIERARQUIAFUNC = FCM_FUNCIONARIOSHIERARQ.NRHIERARQUIAFUNC
                    WHERE FCM_FUNCIONARIOSHIERARQ.CDOPERADORPAI IS NOT NULL
                    AND FCM_HIERARQUIAFUNC.NRLOCALCLIENTE IN (SELECT NRLOCALCLIENTE
                                            FROM FCM_LOCALCLI
                                            START WITH NRLOCALCLIENTE IN ($locais)
                                            CONNECT BY PRIOR NRLOCALCLIENTEPAI = NRLOCALCLIENTE) 
                AND " . $filtro . "
                ORDER BY NMOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findLocal($filtro, $listaLocais)
    {

        $sql = "SELECT FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE
                FROM FCM_LOCALCLI
                JOIN FCM_TIPOLOCALCLI
                ON FCM_TIPOLOCALCLI.NRTIPOLOCALCLI = FCM_LOCALCLI.NRTIPOLOCALCLI
                WHERE" . $filtro . "
                AND FCM_LOCALCLI.IDATIVO = 'S'
                AND FCM_LOCALCLI.NRLOCALCLIENTE IN ($listaLocais)
                ORDER BY FCM_LOCALCLI.NMLOCALCLIENTE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findTipoLocal($filtro)
    {

        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI
                FROM FCM_TIPOLOCALCLI
                WHERE" . $filtro . "
                AND IDATIVO = 'S'
                ORDER BY NMTIPOLOCALCLI";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findContratosTarefas($filtro)
    {

        $sql = "SELECT DISTINCT FCT_CONTRATO.NRSEQCONTRATO, FCT_CONTRATO.NRCONTRATOFCT 
                    FROM FCT_CONTRATO
                    WHERE" . $filtro . "
                    AND FCT_CONTRATO.IDATIVO = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findClientesTarefas($filtro)
    {

        $sql = "SELECT  DISTINCT CLIENTE.NMFANTCLIE, FCM_LOCALCLI.CDCLIENTE
                    FROM CLIENTE
                    JOIN FCM_LOCALCLI
                    ON FCM_LOCALCLI.CDCLIENTE = CLIENTE.CDCLIENTE
                    WHERE" . $filtro . "
                    AND CLIENTE.IDATIVO = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findSolicitacoes($filtro)
    {

        $sql = "SELECT NRSOLICITACAO, NMSOLICITACAO
                  FROM FCM_SOLICITACAO
                 WHERE " . $filtro . " 
              ORDER BY DTSOLICITACAO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findAtividades($filtro)
    {
        $sql = "SELECT NRATIVIDADE, NMATIVIDADE, DSCORIDATIVIDADE 
                    FROM FCM_ATIVIDADE
                    WHERE " . $filtro . " 
                    ORDER BY NMATIVIDADE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findModeloAuditoria($filtro)
    {
        $sql = "SELECT * FROM FCM_MODELOAUDIT
                    WHERE " . $filtro . " 
                    ORDER BY NMMODELOAUDIT";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
