/* eslint-disable */
import { Utilities } from '@/util/Utilities';
import {
    Button, Checkbox, DateRange, FileInput, Form, LoadingService, Modal, ModalService, SelectMultiple, Textarea, TextInput, Text,
} from '@zeedhi/common';
import {
    Http, IDictionary, IEventParam, Metadata,
} from '@zeedhi/core';
import {
    IterableCarousel, IterableComponentRender,
} from '@zeedhi/teknisa-components-common';
import { Loader } from '@googlemaps/js-api-loader';
import FileUpload from './FileUpload';

export class Fm00001TarefasControllerOffline {
    public desabilitarFinalizacaoTarefa: boolean = false;

    public desabilitarChk: boolean = false;

    public visibilidadePaginaInicial: boolean = true;

    public visibilidadeDetalhamento: boolean = false;

    public visibilidadeReportar: boolean = false;

    public visibilidadeCarroselImagens: boolean = false;

    public statusTarefa = '';

    public nomeTarefa = '';

    public localTarefa = '';

    public dataTarefa = '';

    public iniciada: boolean = false;

    public modalFiltrarMinhasTarefas!: Modal;

    public modalVisualizarImagens!: Modal;

    public modalInformacoes!: Modal;

    public modalAnexarImagem!: Modal;

    public nrlocalcli: any;

    private nrChecklistAgend = '';

    public nrChecklistAgendFoto: any;

    private modoAberturaReportar: boolean = false;

    public telaTarefasOffline!: Modal;

    // ---- variáveis que monta as informações adicionais de uma tarefa
    public contrato = '';

    public local = '';

    public cliente = '';

    public tarefa = '';

    public data = '';

    public funcionario = '';

    public situacao = '';
    // -----------

    public async criarModais() {
        this.modalFiltrarMinhasTarefas = await ModalService.createFromJson('fm_00001_000_tarefas_offline/modal/fm_00001_000_filtrar_minhas_tarefas', true);
        this.modalVisualizarImagens = await ModalService.createFromJson('fm_00001_000_tarefas_offline/modal/fm_00001_001_visualizar_imagens', true);
        this.modalAnexarImagem = await ModalService.createFromJson('fm_00001_000_tarefas_offline/modal/fm_00001_000_anexar_imagens', true);
        this.modalInformacoes = await ModalService.createFromJson('fm_00001_000_tarefas_offline/modal/fm_00001_001_dados_tarefa', true);
        this.criaObjetoIndexDb();
        this.setaQtdTarefasEscopoGlobal();
    }

    public destruirModais() {
        ModalService.delete(this.modalFiltrarMinhasTarefas);
        ModalService.delete(this.modalVisualizarImagens);
        ModalService.delete(this.modalAnexarImagem);
        ModalService.delete(this.modalInformacoes);
    }

    public abrirModalFiltrar() {
        this.modalFiltrarMinhasTarefas.show();
    }

    public fecharModalFiltrar() {
        this.modalFiltrarMinhasTarefas.hide();
    }

    public abrirModalAnexar() {
        this.modalAnexarImagem.show();
    }

    public fecharModalAnexar() {
        this.modalAnexarImagem.hide();
    }

    public fecharModalInformacoes() {
        this.modalInformacoes.hide();
    }

    public fecharModalVisualizarImagens() {
        this.modalVisualizarImagens.hide();
    }

    public exibirImagemAnexada({ component }: any) {
        const { datasource } = Metadata.getInstance<IterableCarousel>('carousel-imagens').iterable;
        const imagens: any = [];

        if (component.value.length) {
            this.visibilidadeCarroselImagens = true;
            component.value.forEach((elemento: any, posicao: any) => {
                imagens.push({
                    id: posicao,
                    src: window.URL.createObjectURL(elemento),
                });
            });
        } else {
            this.visibilidadeCarroselImagens = false;
        }

        datasource.updateData(imagens);
    }

    public clickCard({ component }: any) {
        this.visibilidadePaginaInicial = false;
        this.visibilidadeDetalhamento = !this.visibilidadePaginaInicial;

        this.montarInformacoesComplementares(component.name.split('_')[1]);
        this.carregarItensTarefas();
    }

    public retornarPaginaInicial() {
        this.visibilidadePaginaInicial = true;
        this.visibilidadeDetalhamento = !this.visibilidadePaginaInicial;
        this.limparCampos();
    }

    public limparCampos() {
        Metadata.getInstance<Textarea>('box-observation').value = null;
    }

    public alterarBotao({ component }: IEventParam<Button>) {
        const status = Metadata.getInstance<TextInput>('idsituacao');
        if (status.value) {
            if (this.qtdTarAtv === 0 && status.value !== '2') {
                this.estilizarBotao({ component }, 'Iniciar');
                component.disabled = false;
            } else if (this.qtdTarAtv === 1 && status.value === '2') {
                this.estilizarBotao({ component }, 'Finalizar');
                component.disabled = false;
            } else if (this.qtdTarAtv === 1 && status.value !== '2') {
                this.estilizarBotao({ component }, 'Iniciar');
                component.disabled = true;
            }
        }
    }

    public estilizarBotao({ component }: IEventParam<Button>, tipo: any) {
        if (tipo === 'Iniciar') {
            component.label = 'Iniciar Tarefa';
            component.iconName = 'mdi-chevron-right';
            component.color = 'primary';
        } else {
            component.label = 'Finalizar Tarefa';
            component.iconName = 'mdi-chevron-right';
            component.color = 'success';
        }
    }

    public iniciarTarefaAutomaticamente() {
        const botao = Metadata.getInstance<Button>('botao-iniciar-finalizar-tarefa');
        const nr = Metadata.getInstance<TextInput>('nrcheck').value;
        const status = Metadata.getInstance<TextInput>('idsituacao').value;

        if (!this.iniciada && status !== '2') {
            if (this.qtdTarAtv === 0) {
                this.iniciarTarefa(nr, 'iniciar', '2');
                this.estilizarBotao({ component: botao }, 'Finalizar');
                botao.disabled = false;
                this.statusTarefa = "<span  style='background-color: #dee2e6; color: #023e8a; font-size: 11px;'>EM ANDAMENTO</span>";
                this.iniciada = true;
            }
        }
    }

    public async iniciarOuFinalizar({ component }: any) {
        const nr = Metadata.getInstance<TextInput>('nrcheck').value;
        if (!(component.label === 'Iniciar Tarefa')) {
            this.statusTarefa = "<span  style='background-color: #dee2e6; color: green; font-size: 10px;'>C O N C L U Í D O</span>";
            this.finalizarTarefa(nr);
        } else if (await this.iniciarTarefa(nr, 'iniciar', '2')) {
            this.estilizarBotao({ component }, 'Finalizar');
            component.disabled = false;
            this.statusTarefa = "<span  style='background-color: #dee2e6; color: #023e8a; font-size: 11px;'>EM ANDAMENTO</span>";
        }
    }

    public montarInformacoesComplementares(nr: any) {
        LoadingService.show();
        this.nrTarefaAgend = nr;
        const { data } = Metadata.getInstance<IterableComponentRender>('iterable-minhas-tarefas').datasource;
        const observacao = Metadata.getInstance<Textarea>('box-observation');
        const iterable = Metadata.getInstance<IterableComponentRender>('iterable-cards-detalhes');
        const botao = Metadata.getInstance<Button>('botao-iniciar-finalizar-tarefa');

        const dados: any = data.find((row: any) => row.NRCHECKLISTAGEND === Number(nr));

        Metadata.getInstance<TextInput>('nrcheck').value = dados.NRCHECKLISTAGEND;
        Metadata.getInstance<TextInput>('idsituacao').value = dados.IDSITUACAOAGEND;
        this.nomeTarefa = dados.NMCHECKLISTAGEND;
        this.localTarefa = `${dados.NMLOCALCLIENTE} - ${dados.NMLOCALPAI}`;
        this.dataTarefa = `${dados.DTAGEND} ${dados.HORAAGEND}`;
        this.statusTarefa = this.estilizarStatus(dados.SITUACAO);
        this.nrlocalcli = dados.NRLOCALCLIENTE;

        this.alterarBotao({ component: botao });
        this.carregarItens({ component: iterable });
        this.desabilitarCheckbox();

        if (dados.IDOBRIGAOBSERVACAO !== 'S') {
            observacao.clearValidations();
        } else {
            observacao.addValidation('required', {});
        }

        LoadingService.hide();
    }

    // Funções da tela de Detalhamento
    public desabilitarCheckbox() {
        const status = Metadata.getInstance<TextInput>('idsituacao');
        if (this.qtdTarAtv === 1 && status.value !== '2') {
            this.desabilitarChk = true;
        } else if (this.qtdTarAtv === 0) {
            this.desabilitarChk = false;
        } else {
            this.desabilitarChk = false;
        }
    }

    public carregarItens({ component }: IEventParam<IterableComponentRender>) {
        const nr = Metadata.getInstance<TextInput>('nrcheck').value;
        component.datasource.setFilter({
            NRCHECKLISTAGEND: nr,
        });
    }

    public estilizarStatus(status: string) {
        if (status === 'Pendente') {
            return "<span  style='background-color:#dee2e6; color: #ff6700; font-size: 10px;'>P E N D E N T E</span>";
        }
        if (status === 'Em andamento') {
            return "<span  style='background-color: #dee2e6; color: #023e8a; font-size: 11px;'>EM ANDAMENTO</span>";
        }
        if (status === 'Atrasado') {
            return "<span  style='background-color: #dee2e6; color: red; font-size: 10px;'>A T R A S A D O</span>";
        }
        if (status === 'Concluído') {
            return "<span  style='background-color: #dee2e6; color: green; font-size: 10px;'>C O N C L U Í D O</span>";
        }
        return '';
    }

    // Funções da tela de Reportar
    public addTextArea({ component }: IEventParam<Button>) {
        const btOcupado = Metadata.getInstance<Button>('btOcupado');
        const btSemAcesso = Metadata.getInstance<Button>('btSemAcesso');
        const btEspacoLimpo = Metadata.getInstance<Button>('btEspacoLimpo');
        const btOutrosMotivos = Metadata.getInstance<Button>('btOutrosMotivos');
        const textA = Metadata.getInstance<Textarea>('textarea-justificativa');

        btOcupado.outline = !(component.label === btOcupado.label);
        btSemAcesso.outline = !(component.label === btSemAcesso.label);
        btEspacoLimpo.outline = !(component.label === btEspacoLimpo.label);
        btOutrosMotivos.outline = !(component.label === btOutrosMotivos.label);

        if (component.label === btOutrosMotivos.label) {
            textA.isVisible = true;
        } else {
            textA.isVisible = false;
        }
    }

    public abrirReportarBotaoExterno({ component }: IEventParam<Button>) {
        this.visibilidadePaginaInicial = false;
        this.visibilidadeReportar = !this.visibilidadePaginaInicial;
        const nr = component.name.split('_')[1];
        this.nrChecklistAgend = nr;
        this.modoAberturaReportar = true;
    }

    public abrirReportarBotaoInterno() {
        this.visibilidadeDetalhamento = false;
        this.visibilidadeReportar = !this.visibilidadeDetalhamento;
        this.nrChecklistAgend = Metadata.getInstance<TextInput>('nrcheck').value;
        this.modoAberturaReportar = false;
    }

    public limparTelaReportar() {
        Metadata.getInstance<Button>('btOcupado').outline = true;
        Metadata.getInstance<Button>('btSemAcesso').outline = true;
        Metadata.getInstance<Button>('btEspacoLimpo').outline = true;
        Metadata.getInstance<Button>('btOutrosMotivos').outline = true;
        Metadata.getInstance<Textarea>('textarea-justificativa').value = null;
    }

    public fecharPaginaReportar() {
        this.visibilidadeReportar = false;
        if (!this.modoAberturaReportar) {
            this.visibilidadeDetalhamento = true;
        } else {
            this.visibilidadePaginaInicial = true;
        }
        this.limparTelaReportar();
    }

    /*
     ======================================================================================================================================================
     |                                                                   Geolocalização                                                                   |
     ======================================================================================================================================================
    */
    public areaMapa: any;

    public posAtual: any;

    public parametrizacao: any;

    private google: any;

    private map: any;

    public async googleMaps() {
        const geolocalizacao = await this.buscaGeolocalizacaoLocalAtendimento();
        const loader = new Loader({ apiKey: 'AIzaSyCuKQdQJD_Ae2hKegI7xO47taR2XNassuM', libraries: ['drawing', 'geometry'] });
        this.google = await loader.load();
        this.areaMapa = JSON.parse(geolocalizacao.NRGEOLOCALIZACAO);
        const verifica = this.verificarLocation();
        return verifica;
    }

    // FUNÇÃO PARA O FMAPP VERIFICAR SE OPERADOR ESTÁ NA ÁREA CORRETA PAR INICIAR A TAREFA
    public verificarLocation() {
        const map = this.map;
        const novoCirculo = (new this.google.maps.Circle({
            map,
            fillColor: '#ff6961',
            strokeWeight: 2,
            clickable: false,
            editable: false,
            draggable: true,
            radius: parseFloat(this.areaMapa.radius.toFixed(5)),
            center: {
                lat: parseFloat(this.areaMapa.center.lat.toFixed(5)),
                lng: parseFloat(this.areaMapa.center.lng.toFixed(5)),
            },
        })).getBounds();

        return novoCirculo.contains(this.posAtual);
        // return ((this.posAtual.lat - this.areaMapa.center.lat) ** 2) + ((this.posAtual.lng - this.areaMapa.center.lng) ** 2) <= this.areaMapa.radius;
    }

    public async criaMinhaLocalizacao() {
        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition((position: any) => {
                const pos = {
                    lat: position.coords.latitude,
                    lng: position.coords.longitude,
                };
                this.posAtual = pos;
            });
        } else {
            Utilities.alertMessage('Favor verificar as permisões do navegador para localização.', 'error');
        }
    }

    public async buscaGeolocalizacaoLocalAtendimento() {
        let resposta: any = '';
        LoadingService.show();
        await Http.post('/getGeolocalizacao', {
            NRLOCALCLIENTE: this.nrlocalcli,
        }).then((Response: any) => {
            resposta = Response;
            // Utilities.showSuccessMessage();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
        return resposta.data[0];
    }

    public getParametrizaçao() {
        const requestInterno = indexedDB.open(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`, this.controleVersaoBanco());
        requestInterno.onsuccess = () => {
            const db = requestInterno.result;
            const transaction = db.transaction('getParametrizacao', 'readwrite');
            const retorno = transaction.objectStore('getParametrizacao').get(1);
            retorno.onsuccess = () => {
                this.parametrizacao = retorno.result;
            };
        };
    }

    /*
     ======================================================================================================================================================
     |                                                                   APP OFFLINE                                                                      |
     ======================================================================================================================================================
    */

    public request: any;

    public alterarTabelaTarefas: Boolean = false;

    public nrChave = '';

    public idSituacaoAg: any;

    public qtdTarAtv: any;

    public nrTarefaAgend: any;

    public atualizarBancoParam: Boolean = false;

    private dataCard: any = [];

    //  ------------------------------ RESPONSÁVEL POR REALIZAR AS REQUISIÇÕES DO BACKEND E SALVAR NO INDEXDB ------------------------------

    public sendRequestUpdateDataBase() {
        this.getParametrizaçao();
        this.buscarDadosTarefasOffline();
        this.buscaFotosOffline();
        this.buscaQtdTarefasAtivas();
        this.getItensTarefas();
        this.getParams();
        this.getFiltroTarefas();
        this.getFiltroContratos();
        this.getFiltroClientes();
        this.getFiltroLocal();
    }

    public async buscarDadosTarefasOffline() {
        Http.get('/getDadosTarefaOffline').then((Response: any) => {
            const tabela = 'getDadosTarefa';
            const versao = this.controleVersaoBanco();
            const chave = 'NRCHECKLISTAGEND';
            const dados = Response.data.data;
            const index = ' ';
            this.addTabelasIndexDB(tabela, versao, chave, dados, index);
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        });
    }

    public buscaFotosOffline() {
        Http.get('/getFotosTarefasOffline').then((Response: any) => {
            const tabela = 'getFotosAnexo';
            const versao = this.controleVersaoBanco();
            const chave = 'NRFOTOTAREFAAGEND';
            const dados = Response.data.data;
            const index = 'NRCHECKLISTAGEND';
            this.addTabelasIndexDB(tabela, versao, chave, dados, index);
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        });
    }

    public buscaQtdTarefasAtivas() {
        Http.get('/qtdTarefasAtivas').then((response: IDictionary) => {
            const tabela = 'qtdTarefasAtivas';
            const versao = this.controleVersaoBanco();
            const chave = '';
            const dados = {
                ATIVOS: response.data[0].TAREFAATIVA,
                ID: 1,
                NRCHECKLISTAGEND: ' ',
            };
            const index = '';
            this.addTabelasIndexDB(tabela, versao, chave, [dados], index);
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        });
    }

    public getItensTarefas() {
        Http.get('/getItensTarefasOffline').then((response: IDictionary) => {
            const tabela = 'getItensTarefas';
            const versao = this.controleVersaoBanco();
            const chave = 'NRTAREFAAGEND';
            const dados = response.data.data;
            const index = '';
            this.addTabelasIndexDB(tabela, versao, chave, dados, index);
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        });
    }

    public getParams() {
        Http.get('/getGeolocalizacaoParametrizacao').then((Response: any) => {
            const tabela = 'getParametrizacao';
            const versao = this.controleVersaoBanco();
            const chave = 'ID';
            const dados = {
                ID: 1,
                IDUTILIZAGEOLOCAL: Response.data[0].IDUTILIZAGEOLOCAL,
                IDUTILIZAGEOLOCALINITAR: Response.data[0].IDUTILIZAGEOLOCALINITAR,
            };
            const index = '';
            this.addTabelasIndexDB(tabela, versao, chave, [dados], index);
            [this.parametrizacao] = Response.data;
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        });
    }

    public getFiltroTarefas() {
        Http.get('/getTarefasPorOperador').then((Response) => {
            const tabela = 'getFiltroTarefas';
            const versao = this.controleVersaoBanco();
            const chave = 'NRCHECKLISTAGEND';
            const dados = Response.data.data;
            const index = '';
            this.addTabelasIndexDB(tabela, versao, chave, dados, index);
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            this.iniciada = false;
        });
    }

    public getFiltroContratos() {
        Http.get('/findContratosTarefas').then((Response) => {
            const tabela = 'getFiltroContratos';
            const versao = this.controleVersaoBanco();
            const chave = 'NRCHECKLISTAGEND';
            const dados = Response.data.data;
            const index = '';
            this.addTabelasIndexDB(tabela, versao, chave, dados, index);
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            this.iniciada = false;
        });
    }

    public getFiltroClientes() {
        Http.get('/findClientesTarefas').then((Response) => {
            const tabela = 'getFiltroClientes';
            const versao = this.controleVersaoBanco();
            const chave = 'CDCLIENTE';
            const dados = Response.data.data;
            const index = '';
            this.addTabelasIndexDB(tabela, versao, chave, dados, index);
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            this.iniciada = false;
        });
    }

    public getFiltroLocal() {
        Http.get('/findLocal').then((Response) => {
            const tabela = 'getFiltroLocal';
            const versao = this.controleVersaoBanco();
            const chave = 'NRLOCALCLIENTE';
            const dados = Response.data.data;
            const index = '';
            this.addTabelasIndexDB(tabela, versao, chave, dados, index);
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
            this.iniciada = false;
        });
    }

    public addTabelasIndexDB(tabela: any, versao: any, chave: any, dados: any, index: any) {
        const requestInterno = indexedDB.open(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`, versao);
        requestInterno.onupgradeneeded = () => {
            const db = requestInterno.result;
            window.localStorage.setItem('DB_VERSION', db.version.toString());
            const store = db.createObjectStore(tabela, { keyPath: chave });
            if (tabela === 'getFotosAnexo') {
                store.createIndex('Chave_NRCHECKLISTAGEND', index, { unique: false });
            }
        };
        requestInterno.onsuccess = () => {
            const db = requestInterno.result;
            const transaction = db.transaction(tabela, 'readwrite').objectStore(tabela);
            dados.forEach((element: any) => {
                transaction.put(element);
            });
        };
        requestInterno.onerror = (event: any) => {
            console.error('An error occurred with IndexedDB');
            console.warn(event.target.errorCode);
        };
    }

    // ------------------------------ Funções para controle de versão do banco e parametrização do APP OFFLINE ------------------------------------------------------------
    public inicializarTabelas() {
        const versao = this.controleVersaoBanco();
        const requestInterno = indexedDB.open(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`, versao);
        requestInterno.onupgradeneeded = () => {
            const db = requestInterno.result;
            window.localStorage.setItem('DB_VERSION', db.version.toString());
            db.createObjectStore('getDadosTarefa', { keyPath: 'NRCHECKLISTAGEND' });
            db.createObjectStore('getFotosAnexo', { keyPath: 'NRFOTOTAREFAAGEND' }).createIndex('Chave_NRCHECKLISTAGEND', 'NRCHECKLISTAGEND', { unique: false });
            db.createObjectStore('setReport', { keyPath: 'NRCHECKLISTAGEND' });
            db.createObjectStore('setFoto', { autoIncrement: true }).createIndex('Chave_NRCHECKLISTAGEND', 'NRCHECKLISTAGEND', { unique: false });
            db.createObjectStore('removeFoto', { keyPath: 'NRFOTOTAREFAAGEND' });
            db.createObjectStore('tarefaIniciada', { keyPath: 'NRCHECKLISTAGEND' });
            db.createObjectStore('tarefaFinalizada', { keyPath: 'NRCHECKLISTAGEND' });
            db.createObjectStore('qtdTarefasAtivas', { keyPath: 'ID' });
            db.createObjectStore('getItensTarefas', { keyPath: 'NRTAREFAAGEND' }).createIndex('Chave_NRCHECKLISTAGEND', 'NRCHECKLISTAGEND', { unique: false });
            db.createObjectStore('getParametrizacao', { keyPath: 'ID' });
            db.createObjectStore('getFiltroTarefas', { keyPath: 'NRCHECKLISTAGEND' });
            db.createObjectStore('getFiltroContratos', { keyPath: 'NRSEQCONTRATO' });
            db.createObjectStore('getFiltroClientes', { keyPath: 'CDCLIENTE' });
            db.createObjectStore('getFiltroLocal', { keyPath: 'NRLOCALCLIENTE' });
        };

        requestInterno.onsuccess = () => {
            Utilities.alertMessage('Dados atualizados com sucesso.', 'success');
            this.sendRequestUpdateDataBase();
        }

        requestInterno.onerror = (event: any) => {
            Utilities.alertMessage('Ocorreu um erro ao atualizar banco de dados.', 'error');
            console.warn(event.target.errorCode);
        };
    }

    public controleVersaoBanco() {
        const versaoAtualBanco: any = window.localStorage.getItem('DB_VERSION');
        let versaoBancoAtual = Number(versaoAtualBanco);
        if (this.atualizarBancoParam) {
            versaoBancoAtual++;
            this.atualizarBancoParam = false;
        }
        return versaoBancoAtual;
    }

    // Esta função é para solucionar um problema de não ter o Objeto indexDB disponível a todo momento. Com ela, podemos acessa-lo através da var this.request
    public criaObjetoIndexDb() {
        const versaoBanco = this.controleVersaoBanco();
        const requestInterno = indexedDB.open(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`, versaoBanco);
        this.request = requestInterno;
    }

    public exibirModalVisualizarImagens({ component }: any) {
        const nr = Number(component.name.split('_')[1]);
        this.nrChecklistAgendFoto = nr;
        this.modalVisualizarImagens.show();
    }

    public atualizaDadosBanco(tabela: any, versao: any, request: any, dados: any, index: any) {
        const requestInterno = indexedDB.open(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`, versao);

        requestInterno.onsuccess = () => {
            const db = requestInterno.result;
            const transaction = db.transaction(tabela, 'readwrite');
            const store = transaction.objectStore(tabela);
            const retorno = store.get(Number(index));

            retorno.onsuccess = () => {
                switch (request) {
                    case 'setReport':
                        retorno.result.IDSITUACAOAGEND = '3';
                        retorno.result.SITUACAO = 'Cancelado';
                        break;

                    case 'tarefaIniciada':
                        retorno.result.IDSITUACAOAGEND = '2';
                        retorno.result.SITUACAO = 'Em andamento';
                        break;

                    case 'tarefaFinalizada':
                        retorno.result.IDSITUACAOAGEND = '4';
                        retorno.result.SITUACAO = 'Concluído';
                        break;

                    case 'setFoto':
                        retorno.result.NRFOTOTAREFAAGEND = dados.NRFOTOTAREFAAGEND;
                        retorno.result.NRCHECKLISTAGEND = dados.NRCHECKLISTAGEND;
                        break;
                }

                store.put(retorno.result);
            };

            retorno.onerror = (event: any) => {
                console.warn(event.target.errorCode);
            };
        };
    }

    public setaQtdTarefasEscopoGlobal() {
        const requestInterno = indexedDB.open(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`, this.controleVersaoBanco());

        requestInterno.onsuccess = () => {
            const db = requestInterno.result;
            const transaction = db.transaction('qtdTarefasAtivas', 'readwrite');
            const store = transaction.objectStore('qtdTarefasAtivas');
            const retorno = store.get(1);

            retorno.onsuccess = () => {
                this.qtdTarAtv = retorno.result.ATIVOS;
            };

            retorno.onerror = (event: any) => {
                console.warn(event.target.errorCode);
            };

            transaction.oncomplete = () => {
                db.close();
            };
        };

        requestInterno.onerror = (event: any) => {
            console.warn(event.target.errorCode);
        };
    }

    public mudaValorQtdTarAtiva(valor: String, nr: any, report: any) {
        const requestInterno = indexedDB.open(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`, this.controleVersaoBanco());
        let valorAlterar: number = 0;
        let nrAgend: number = 0;
        if (valor === 'iniciar') {
            valorAlterar = 1;
            nrAgend = nr;
        } else {
            valorAlterar = 0;
            nrAgend = 0;
        }

        requestInterno.onsuccess = () => {
            const db = requestInterno.result;
            const transaction = db.transaction('qtdTarefasAtivas', 'readwrite');
            const store = transaction.objectStore('qtdTarefasAtivas');
            const retorno = store.get(1);

            retorno.onsuccess = () => {
                if (report === true && nr === retorno.result.NRCHECKLISTAGEND) {
                    valorAlterar = 0;
                }
                this.qtdTarAtv = valorAlterar;
                retorno.result.ATIVOS = valorAlterar;
                retorno.result.NRCHECKLISTAGEND = nrAgend;
                store.put(retorno.result);
            };

            retorno.onerror = (event: any) => {
                console.warn(event.target.errorCode);
            };

            transaction.oncomplete = () => {
                db.close();
            };
        };
    }

    // ------------------------------ FUNÇÕES PARA REALIZAR A BUSCA NO INDEXDB E SETAR NOS CARDS/MODAIS ------------------------------
    public exibirModalInformacoes({ component }: any) {
        const requestInterno = this.request;
        const db = requestInterno.result;
        const retorno = db.transaction('getDadosTarefa', 'readwrite').objectStore('getDadosTarefa').get(Number(component.name.split('_')[1]));

        retorno.onsuccess = (event: any) => {
            const dados = event.target.result;
            this.contrato = (dados.NRCONTRATOFCT === null) ? 'Não há' : dados.NRCONTRATOFCT;
            this.cliente = dados.NMRAZSOCCLIE;
            this.tarefa = dados.NMCHECKLISTAGEND;
            this.local = `${dados.NMLOCALCLIENTE} - ${dados.NMLOCALPAI}`;
            this.data = `${dados.DTAGEND} - ${dados.HORAAGEND}`;
            this.funcionario = dados.NMOPERADOR;
            this.situacao = dados.SITUACAO;
        };
        this.modalInformacoes.show();

        retorno.onerror = (event: any) => {
            console.warn(event.target.errorCode);
        };
    }

    public carregarFotosTarefas({ component }: any) {
        const nr = this.nrChecklistAgendFoto;
        const btnApagar = Metadata.getInstance<Button>('botao-apagar-imagens');

        const requestInterno = this.request;
        const db = requestInterno.result;
        const transaction = db.transaction('getFotosAnexo', 'readwrite');
        const store = transaction.objectStore('getFotosAnexo');
        const index = store.index('Chave_NRCHECKLISTAGEND');
        const retorno = index.getAll(nr);

        retorno.onsuccess = (event: any) => {
            const dados = event.target.result;
            if (dados.length === 0) {
                component.isVisible = false;
                Metadata.getInstance<Text>('sem-resultado-imagens-tarefas').isVisible = true;
                btnApagar.isVisible = false;
            } else {
                dados.forEach((element: any) => {
                    component.iterable.datasource.data.push({
                        NRFOTOTAREFAAGEND: element.NRFOTOTAREFAAGEND,
                        DSFOTOTAREFAAGEND: element.DSFOTOTAREFAAGEND,
                    });
                });
                btnApagar.isVisible = true;
            }
        };

        retorno.onerror = (event: any) => {
            console.warn(event.target.errorCode);
        };
    }

    public filtroData(value: any, dataRange: any) {
        if (dataRange && dataRange.length) {
            let ano = new Date();
            const [dia, mes] = value.DTAGEND.split('/');
            const dataCard = new Date(ano.getFullYear(), mes - 1, dia);
            let dataTarefa = dataCard.valueOf()
            const [diaRI, mesRI, anoRI] = dataRange[0].split('/');
            const dataRangeInicial = new Date(anoRI, mesRI - 1, diaRI);

            if (dataRange[1]) { // Validação caso a data está entre o range
                const [diaRF, mesRF, anoRF] = dataRange[1].split('/');
                const dataRangeFinal = new Date(anoRF, mesRF - 1, diaRF);
                if (dataTarefa >= dataRangeInicial.valueOf() && dataTarefa <= dataRangeFinal.valueOf()) {
                    this.dataCard.push(value);
                }
            } else { // verificar se as são iguais ou após a data escolhida
                if (dataTarefa >= dataRangeInicial.valueOf()) {
                    this.dataCard.push(value);
                }
            }
        }
    }

    public validaFiltroTarefas(value: any, filtro: any) {
        this.dataCard = [];
        if (((filtro === null) || (filtro.NRCHECKLISTAGEND === undefined && filtro.NRSEQCONTRATO === undefined && filtro.CDCLIENTE === undefined && filtro.NRLOCALCLIENTE === undefined))) {
            value.forEach((element: any) => {
                this.dataCard.push(element);
            });
        } else {
            value.forEach((value: any) => {
                if (filtro.NRCHECKLISTAGEND !== undefined && filtro.NRCHECKLISTAGEND.length > 0) {
                    filtro.NRCHECKLISTAGEND.forEach((element: any) => {
                        if (value.NRCHECKLISTAGEND === element) {
                            this.dataCard.push(value);
                        }
                    });
                } else if (filtro.NRSEQCONTRATO !== undefined && filtro.NRSEQCONTRATO.length > 0) {
                    filtro.NRSEQCONTRATO.forEach((element: any) => {
                        if (value.NRSEQCONTRATO === element) {
                            this.dataCard.push(value);
                        }
                    });
                } else if (filtro.CDCLIENTE !== undefined && filtro.CDCLIENTE.length > 0) {
                    filtro.CDCLIENTE.forEach((element: any) => {
                        if (value.CDCLIENTE === element) {
                            this.dataCard.push(value);
                        }
                    });
                } else if (filtro.NRLOCALCLIENTE != undefined && filtro.NRLOCALCLIENTE.length > 0) {
                    filtro.NRLOCALCLIENTE.forEach((element: any) => {
                        if (value.NRLOCALCLIENTE === element) {
                            this.dataCard.push(value);
                        }
                    });
                } else if (filtro.DTHORAGEND !== undefined && filtro.DTHORAGEND.length > 0) {
                    this.filtroData(value, filtro.DTHORAGEND);
                }
            });
        }
    }

    public manipularDataSort(a: any, b: any) {
        const ano = new Date();
        const dataA = a.DTAGEND.split('/');
        const dataB = b.DTAGEND.split('/');
        const [horaA, minutoA] = a.HORAAGEND.split(':');
        const [horaB, minutoB] = a.HORAAGEND.split(':');
        let data1: any = new Date(ano.getFullYear(), dataA[1], dataA[0], horaA, minutoA);
        let data2: any = new Date(ano.getFullYear(), dataB[1], dataB[0], horaB, minutoB);
        return data1 - data2;
    }

    public carregarCardsMinhasTarefas(filtro: any) {
        this.getParametrizaçao();

        const card = Metadata.getInstance<IterableComponentRender>('iterable-minhas-tarefas');
        const requestInterno = indexedDB.open(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`, this.controleVersaoBanco());
        requestInterno.onsuccess = () => {
            const db = requestInterno.result;
            const retorno = db.transaction('getDadosTarefa', 'readwrite').objectStore('getDadosTarefa').getAll();
            card.datasource.data = [];
            retorno.onsuccess = () => {
                this.validaFiltroTarefas(retorno.result, filtro);
                let arrayOrdenado = this.dataCard.sort(this.manipularDataSort)
                arrayOrdenado.forEach((element: any) => {
                    card.datasource.data.push({
                        CDCLIENTE: element.CDCLIENTE,
                        CDOPERADOR: element.CDOPERADOR,
                        DTAGEND: element.DTAGEND,
                        HORAAGEND: element.HORAAGEND,
                        IDOBRIGAOBSERVACAO: element.IDOBRIGAOBSERVACAO,
                        IDSITUACAOAGEND: element.IDSITUACAOAGEND,
                        LOCALPAI: element.LOCALPAI,
                        NMCHECKLIST: element.NMCHECKLIST,
                        NMCHECKLISTAGEND: element.NMCHECKLISTAGEND,
                        NMLOCALCLIENTE: element.NMLOCALCLIENTE,
                        NMLOCALPAI: element.NMLOCALPAI,
                        NMOPERADOR: element.NMOPERADOR,
                        NMRAZSOCCLIE: element.NMRAZSOCCLIE,
                        NRCHECKLIST: element.NRCHECKLIST,
                        NRCHECKLISTAGEND: element.NRCHECKLISTAGEND,
                        NRCONTRATOFCT: element.NRCONTRATOFCT,
                        NRLOCALCLIENTE: element.NRLOCALCLIENTE,
                        NRSEQCONTRATO: element.NRSEQCONTRATO,
                        RNUM: element.RNUM,
                        SITUACAO: element.SITUACAO,
                        TOTAL_LINES: element.TOTAL_LINES,
                    });
                });
            };
        };

        requestInterno.onerror = (event: any) => {
            console.error('An error occurred with IndexedDB');
            console.warn(event.target.errorCode);
        };
    }

    public carregarItensTarefas() {
        const card = Metadata.getInstance<IterableComponentRender>('iterable-cards-detalhes');
        const requestInterno = indexedDB.open(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`, this.controleVersaoBanco());
        const nr = Number(this.nrTarefaAgend);

        requestInterno.onsuccess = () => {
            const db = requestInterno.result;
            const retorno = db.transaction('getItensTarefas', 'readwrite').objectStore('getItensTarefas').index('Chave_NRCHECKLISTAGEND').getAll(nr);
            card.datasource.data = [];
            retorno.onsuccess = () => {
                const dados = retorno.result;
                dados.forEach((element: any) => {
                    card.datasource.data.push({
                        CDOPERADOR: element.CDOPERADOR,
                        DTHORATAREFAAGEND: element.DTHORATAREFAAGEND,
                        IDREALIZADO: element.IDREALIZADO,
                        NMTAREFA: element.NMTAREFA,
                        NRCHECKLISTAGEND: element.NRCHECKLISTAGEND,
                        NRTAREFAAGEND: element.NRTAREFAAGEND,
                        NRTAREFACHK: element.NRTAREFACHK,
                    });
                });
            };
        };
    }

    // ------------------------------ FUNÇÕES QUE SALVAM OS DADOS NO INDEXDB PARA POSTERIORMENTE SINCRONIZAR COM O BACKEND ------------------------------
    public excluirFoto() {
        const carrosel = Metadata.getInstance<IterableCarousel>('carousel-imagens-anexo-tarefas');
        const img = carrosel.iterable.datasource.data;
        const [deleteData] = img.filter((value: any, index: any) => index === carrosel.currentSlide);

        const requestInterno = this.request;
        const db = requestInterno.result;
        const transaction = db.transaction('getFotosAnexo', 'readwrite');
        const store = transaction.objectStore('getFotosAnexo');
        const deletarFoto = store.delete(deleteData.NRFOTOTAREFAAGEND);

        deletarFoto.onsuccess = () => {
            const data = img.filter((value: any, index: any) => index !== carrosel.currentSlide);
            carrosel.iterable.datasource.updateData(data);
        };

        const tabela = 'removeFoto';
        const versao = this.controleVersaoBanco();
        const chave = 'NRFOTOTAREFAAGEND';
        const index = '';

        this.addTabelasIndexDB(tabela, versao, chave, [deleteData], index);

    }

    public reportar() {
        let justify = ['btOcupado', 'btSemAcesso', 'btEspacoLimpo', 'btOutrosMotivos'].filter((nameButton: string) => Metadata.getInstance<Button>(nameButton).outline === false)[0];
        if (justify === 'btOutrosMotivos') {
            justify = (Metadata.getInstance<Textarea>('textarea-justificativa').value.trim().replace(' ', '').length > 0) ? Metadata.getInstance<Textarea>('textarea-justificativa').value.trim() : justify;
        } else {
            justify = Metadata.getInstance<Button>(justify).label;
        }
        const tabela = 'setReport';
        const versao = this.controleVersaoBanco();
        const chave = 'NRCHECKLISTAGEND';
        const index = '';
        const dados = {
            NRCHECKLISTAGEND: Number(this.nrChecklistAgend),
            TIPO: 'reportar',
            IDSITUACAOAGEND: '3',
            DSJUSTCANCELAMENTO: justify,
        };
        this.idSituacaoAg = 3;

        this.addTabelasIndexDB(tabela, versao, chave, [dados], index);

        if (justify !== 'btOutrosMotivos') {
            this.atualizaDadosBanco('getDadosTarefa', versao, tabela, dados, Number(this.nrChecklistAgend));
            this.mudaValorQtdTarAtiva(' ', Number(this.nrChecklistAgend), true);
            this.carregarCardsMinhasTarefas(null);
            this.visibilidadeReportar = false;
            this.visibilidadePaginaInicial = true;
        } else {
            Utilities.alertMessage('Favor preencher o motivo', 'error');
        }
    }

    public async anexarImagens() {
        const imagensConvertidas = await FileUpload.converterImagens('file-input-anexar-imagem');
        const fileInput = Metadata.getInstance<FileInput>('file-input-anexar-imagem');
        if (fileInput.value) {
            const tabela = 'setFoto';
            const versao = this.controleVersaoBanco();
            const chave = '';
            const index = 'NRCHECKLISTAGEND';
            const dados = {
                IMAGENS: imagensConvertidas,
                NRCHECKLISTAGEND: Number(Metadata.getInstance<TextInput>('nrcheck').value),
                // NRFOTOTAREFAAGEND: Math.floor(Math.random() * 300 + 200),
            };
            this.addTabelasIndexDB(tabela, versao, chave, [dados], index);
            Utilities.alertMessage('Foto Anexada com sucesso!', 'success');
            // this.atualizaDadosBanco("getFotosAnexo", versao, tabela, dados, dados.NRFOTOTAREFAAGEND);
            this.fecharModalAnexar();
        } else {
            Utilities.alertMessage('Nenhuma imagem foi anexada', 'error');
        }
    }

    public async iniciarTarefa(nr: any, tipo: string, id: any) {
        this.criaMinhaLocalizacao();
        let validador;
        if (this.parametrizacao.IDUTILIZAGEOLOCALINITAR === 'S') {
            validador = await this.googleMaps();
        }
        if (validador !== false) {

            const tabela = 'tarefaIniciada';
            const versao = this.controleVersaoBanco();
            const chave = 'NRCHECKLISTAGEND';
            const index = ' ';
            const dados = {
                NRCHECKLISTAGEND: Number(nr),
                TIPO: 'iniciar',
                IDSITUACAOAGEND: id,
                SITUACAO: 'Em andamento',
            };
            this.addTabelasIndexDB(tabela, versao, chave, [dados], index);
            Utilities.alertMessage('Tarefa iniciada com sucesso!', 'success');
            this.atualizaDadosBanco('getDadosTarefa', versao, tabela, dados, Number(nr));
            this.mudaValorQtdTarAtiva('iniciar', Number(nr), false);
            this.carregarCardsMinhasTarefas(null);
            return true;
        }
        Utilities.alertMessage('Você está fora da local para inicio da tarefa.', 'error');
        return false;
    }

    public finalizarTarefa(nr: any) {
        const chkbox: IDictionary = [];
        const formObs = Metadata.getInstance<Form>('Form-observation');

        Metadata.getInstance<IterableComponentRender>('iterable-cards-detalhes').datasource.data.forEach((itens: IDictionary) => {
            if (Metadata.getInstance<Checkbox>(`checkbox_${itens.NRTAREFAAGEND}`).value) {
                chkbox.push(itens.NRTAREFAAGEND);
            }
        });
        if (Utilities.validateForm(formObs)) {
            const tabela = 'tarefaFinalizada';
            const versao = this.controleVersaoBanco();
            const chave = 'NRCHECKLISTAGEND';
            const index = ' ';
            const dados = {
                NRCHECKLISTAGEND: Number(nr),
                CHKBOX: chkbox,
                DSOBSTAREFAAGEND: Metadata.getInstance<Textarea>('box-observation').value,
            };
            this.addTabelasIndexDB(tabela, versao, chave, [dados], index);
            Utilities.alertMessage('Tarefa finalizada com sucesso!', 'success');
            this.atualizaDadosBanco('getDadosTarefa', versao, tabela, dados, Number(nr));
            this.mudaValorQtdTarAtiva('finalizar', Number(nr), false);
            this.visibilidadeDetalhamento = false;
            this.visibilidadePaginaInicial = true;
            this.limparCampos();
            this.carregarCardsMinhasTarefas(null);
        }
    }

    // ------------------------------ FUNÇÕES PARA SINCRONIZAR DADOS COM BACKEND ------------------------------
    public prepararDadosIndexDb() {
        if (navigator.onLine) {
            LoadingService.show();
            let TAREFAINICIADA: any[];
            let TAREFASFINALIZADAS: any[];
            let FOTOSANEXADAS: any[];
            let FOTOSREMOVIDAS: any[];
            let TAREFASREPORTADAS: any[];
            const request = indexedDB.open(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`, this.controleVersaoBanco());
            request.onsuccess = () => {
                const db = request.result;

                const tarefaIniciada = db.transaction('tarefaIniciada', 'readwrite').objectStore('tarefaIniciada').getAll();
                tarefaIniciada.onsuccess = () => {
                    TAREFAINICIADA = tarefaIniciada.result;
                };

                const tarefaFinalizada = db.transaction('tarefaFinalizada', 'readwrite').objectStore('tarefaFinalizada').getAll();
                tarefaFinalizada.onsuccess = () => {
                    TAREFASFINALIZADAS = tarefaFinalizada.result;
                };

                const setFoto = db.transaction('setFoto', 'readwrite').objectStore('setFoto').getAll();
                setFoto.onsuccess = () => {
                    FOTOSANEXADAS = setFoto.result;
                };

                const removeFoto = db.transaction('removeFoto', 'readwrite').objectStore('removeFoto').getAll();
                removeFoto.onsuccess = () => {
                    FOTOSREMOVIDAS = removeFoto.result;
                };

                const setReport = db.transaction('setReport', 'readwrite').objectStore('setReport').getAll();
                setReport.onsuccess = () => {
                    TAREFASREPORTADAS = setReport.result;
                };

            }

            request.onerror = (event: any) => {
                console.warn(event.target.errorCode);
            };

            setTimeout(() => {
                this.syncDadosBackEnd(TAREFAINICIADA, TAREFASFINALIZADAS, FOTOSANEXADAS, FOTOSREMOVIDAS, TAREFASREPORTADAS);
            }, 3000);
        } else {
            Utilities.alertMessage('No momento não é possível sinrconizar. Sem conexão com a internet.', 'error');
        }

    }

    public syncDadosBackEnd(TAREFAINICIADA: any, TAREFASFINALIZADAS: any, FOTOSANEXADAS: any, FOTOSREMOVIDAS: any, TAREFASREPORTADAS: any) {
        Http.post('/syncDadosBackend', {
            TAREFAINICIADA: TAREFAINICIADA,
            TAREFASFINALIZADAS: TAREFASFINALIZADAS,
            FOTOSANEXADAS: FOTOSANEXADAS,
            FOTOSREMOVIDAS: FOTOSREMOVIDAS,
            TAREFASREPORTADAS: TAREFASREPORTADAS,
        }).then(() => {
            Utilities.showSuccessMessage();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            window.location.reload();
            LoadingService.hide();
            this.iniciada = false;
        });
        Utilities.alertMessage('Sincronismo realizado com sucesso.', 'success');
        const req = indexedDB.deleteDatabase(`Tarefa_${window.localStorage.getItem("CDOPERADOR")}`);
        req.onsuccess = () => {
            console.warn('Deleted database successfully');
        };
        req.onerror = () => {
            console.warn('Couldnt delete database');
        };
        req.onblocked = () => {
            console.warn('Couldnt delete database due to the operation being blocked');
        };
        window.location.reload();
    }

    // ------------------------------ Controle dos Filtros ------------------------------
    public filtrarCards() {
        const filtros = {
            CDCLIENTE: Metadata.getInstance<SelectMultiple>('filtro-cliente').value,
            NRLOCALCLIENTE: Metadata.getInstance<SelectMultiple>('filtro-local').value,
            NRSEQCONTRATO: Metadata.getInstance<SelectMultiple>('filtro-contratos').value,
            NRCHECKLISTAGEND: Metadata.getInstance<SelectMultiple>('filtro-tarefas').value,
            DTHORAGEND: Metadata.getInstance<DateRange>('data').value,
            TIPO: 2,
        };
        this.carregarCardsMinhasTarefas(filtros);
        this.fecharModalFiltrar();
    }

    public montarSelectsFiltros() {
        const requestInterno = this.request;
        const db = requestInterno.result;
        const filtroTarefas = Metadata.getInstance<SelectMultiple>('filtro-tarefas');
        const filtroContratos = Metadata.getInstance<SelectMultiple>('filtro-contratos');
        const filtroClientes = Metadata.getInstance<SelectMultiple>('filtro-cliente');
        const filtroLocal = Metadata.getInstance<SelectMultiple>('filtro-local');

        const tarefas = db.transaction('getFiltroTarefas', 'readonly').objectStore('getFiltroTarefas').getAll();
        tarefas.onsuccess = () => {
            filtroTarefas.datasource.updateData(tarefas.result);
        };

        const clientes = db.transaction('getFiltroClientes', 'readonly').objectStore('getFiltroClientes').getAll();
        clientes.onsuccess = () => {
            filtroClientes.datasource.updateData(clientes.result);
        };

        const local = db.transaction('getFiltroLocal', 'readonly').objectStore('getFiltroLocal').getAll();
        local.onsuccess = () => {
            filtroLocal.datasource.updateData(local.result);
        };

        const contrato = db.transaction('getFiltroContratos', 'readonly').objectStore('getFiltroContratos').getAll();
        contrato.onsuccess = () => {
            filtroContratos.datasource.updateData(contrato.result);
        };
    }

    public limparFiltros() {
        Metadata.getInstance<SelectMultiple>('filtro-cliente').value = null;
        Metadata.getInstance<SelectMultiple>('filtro-local').value = null;
        Metadata.getInstance<SelectMultiple>('filtro-contratos').value = null;
        Metadata.getInstance<SelectMultiple>('filtro-tarefas').value = null;
        Metadata.getInstance<DateRange>('data').value = null;

        this.carregarCardsMinhasTarefas(null);
    }
}
